import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StreamTokenizer;



public class TwiceSeven_naive_er {

	public static void main(String[] args) throws IOException {
		BraveLittleTaylor blt = new BraveLittleTaylor();
		blt.solve();
		blt.print();
	}

}

class BraveLittleTaylor {
	
	BraveLittleTaylor() throws IOException {
		in = new StreamTokenizer(new BufferedReader(new InputStreamReader(System.in)));
		n = nextInt();
		k = nextInt();
		s = new int[n];
		for (int i = 0; i < n; i++){
			s[i] = nextInt();
		}
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	void all() {
		answer = 0;
		for (int i = 0; i < n; i++){
			answer += s[i];
		}
	}
	
	void notall() {
		// call only n > 2*k
		nk = n - (k-1);
		s1 = new int[nk];
		for (int i = 0; i < k; i++){
			s1[0] += s[i];
		}
		
		for (int i = k; i < n; i++) {
			s1[i-k+1] = s1[i-k] - s[i-k] + s[i];
		}
		
		ms1 = new int[nk];
		ms1[nk-1] = s1[nk-1];
		for (int i = nk-2; i >= 0; i--){
			if (s1[i] > ms1[i+1]) {
				ms1[i] = s1[i];
			}
			else {
				ms1[i] = ms1[i+1];
			}
		}
		
		answer = -1;
		for (int i = 0; i < nk-k; i++){
			if ((s1[i] + ms1[i+k]) > answer) {
				answer = s1[i] + ms1[i+k];
			}
		}
	}
	
	void solve() {
		if (n <= 2*k){
			all();
		}
		else {
			notall();
		}
	}
	
	void print() throws IOException {
		PrintWriter out = new PrintWriter(System.out);
		out.println(answer);
		out.flush();
		out.close();
	}
	
	StreamTokenizer in;
	
	int answer; 
	
	int n;
	int k;
	int [] s;
	int [] s1; // first sweep starts head #i
	int [] ms1; // maximum if first head was #i
	
	int nk; 
}