//Autor: Oliver-Matis Lill
//50p grupid 1, 2, 3, 4
//O(n log m) lahendus 
//Tüüp: Binary search, DP, greedy
//
//Lahnedus kasutab ära asjaolu, et iga mooduli kasutamisega saadud summaarne
//aeg sõltub lineaarselt lõppu jõudmise ajast. Seda asjaolu kasutades saab
//kahte moodulit võrreldes leida, mis punktist hakkab ühe mooduli kasutamine
//teisest parem olema. Me saame lihtsalt need moodulid sorteerida selle järgi,
//mis punktist alates need muutuvad optimaalseks ja siis dünaamilise planeerimisega
//leida, mis teleporteris mis moodulit on optimaalne kasutada parima aja saamiseks.


#include<iostream>
#include<vector>
#include<algorithm>
#include<fstream>
#include<iomanip>
#define f first
#define s second
#define mp make_pair
using namespace std;


int n, m, p1, p2, p3, L;
double d1, opt[200002];

//Format: (cost, reduce)
pair<double, double> inimodule[200002];
vector<double> modbeg;
vector<pair<double, double> > module;

vector<int> xp;

vector<pair<int, int> > edge;


vector<int> conn[200002];


bool dpsort(pair<double, double> l, pair<double, double> r) {
	return mp(l.f, -l.s) < mp(r.f, -r.s);
}


//---------------------------------------------------------------------
//Main function here

int main() {
	ifstream in("telesis.txt");
	in >> n >> m >> L;

	xp.push_back(L);
	xp.push_back(0);
	
	for(int i=0;i<n;i++) {
		in >> p1 >> p2;
		
		xp.push_back(p1);
		xp.push_back(p2);
		edge.push_back(mp(p1, p2));
	}
	
	sort(xp.begin(), xp.end());
	xp.resize(unique(xp.begin(), xp.end() ) - xp.begin() );
	
	for(int i=0;i<edge.size();i++) {
		int start = lower_bound(xp.begin(), xp.end(), edge[i].f) - xp.begin();
		int finish = lower_bound(xp.begin(), xp.end(), edge[i].s) - xp.begin();
		
		conn[start].push_back(finish);
	}
	
	
	
	for(int i=0;i<m;i++) {
		in >> inimodule[i].f >> inimodule[i].s;
		inimodule[i].s = 1 - 1.0 / inimodule[i].s;
	}
	
	
	sort(inimodule, inimodule + m, dpsort);
	
	modbeg.push_back(-1000000000);
	module.push_back(inimodule[0]);
	
	for(int i=1;i<m;i++) {
		bool done = false;
		
		while(!done) {
			if(module.size() == 0) {
				module.push_back(inimodule[i]);
				modbeg.push_back(-1000000000);
				done = true;
				continue;
			}
			
			if(inimodule[i].s <= module.back().s) {
				done = true;
				continue;
			}
			
			double curbeg = (inimodule[i].f - module.back().f) / (inimodule[i].s - module.back().s);
			
			if(curbeg <= modbeg.back()) {
				module.pop_back();
				modbeg.pop_back();
			}
			
			else {
				module.push_back(inimodule[i]);
				modbeg.push_back(curbeg);
				done = true;
			}
		}
	}
	
	
	
	//Now we perform the DP calculation
	
	for(int i=xp.size()-2;i>=0;i--) {
		opt[i] = opt[i+1] + xp[i+1] - xp[i];
		
		for(int j=0;j<conn[i].size();j++) {
			int modind = upper_bound(modbeg.begin(), modbeg.end(), opt[conn[i][j]]) - modbeg.begin() - 1;
			
			opt[i] = min(opt[i], module[modind].f + (1 - module[modind].s) * opt[conn[i][j]] );
		}
	}
	
	ofstream out("televal.txt");
	out << fixed << setprecision(4) << opt[0] << '\n';
	return 0;
}


































